[51Nod1716]多项式? 题解
题目地址:51Nod …
May all the beauty be blessed.
题目地址:洛谷:【P2179】[NOI2012]骑行川藏 – 洛谷、BZOJ:Problem 2876. — [Noi2012]骑行川藏
蛋蛋非常热衷于挑战自我,今年暑假他准备沿川藏线骑着自行车从成都前往拉萨。川藏线的沿途有着非常美丽的风景,但在这一路上也有着很多的艰难险阻,路况变化多端,而蛋蛋的体力十分有限,因此在每天的骑行前设定好目的地、同时合理分配好自己的体力是一件非常重要的事情。
由于蛋蛋装备了一辆非常好的自行车,因此在骑行过程中可以认为他仅在克服风阻做功(不受自行车本身摩擦力以及自行车与地面的摩擦力影响)。某一天他打算骑N段路,每一段内的路况可视为相同:对于第i段路,我们给出有关这段路况的3个参数 si , ki , vi’ ,其中 si 表示这段路的长度, ki 表示这段路的风阻系数, vi’ 表示这段路上的风速(表示在这段路上他遇到了顺风,反之则意味着他将受逆风影响)。若某一时刻在这段路上骑车速度为v,则他受到的风阻大小为 F = ki ( v – vi’ )^2(这样若在长度为s的路程内保持骑行速度v不变,则他消耗能量(做功)E = ki ( v – vi’ )^2 s)。
设蛋蛋在这天开始时的体能值是 Eu ,请帮助他设计一种行车方案,使他在有限的体力内用最短的时间到达目的地。请告诉他最短的时间T是多少。
输入格式:
第一行包含一个正整数N和一个实数Eu,分别表示路段的数量以及蛋蛋的体能值。
接下来N行分别描述N个路段,每行有3个实数 si , ki , vi’ ,分别表示第 i 段路的长度,风阻系数以及风速。
输出格式:
输出一个实数T,表示蛋蛋到达目的地消耗的最短时间,要求至少保留到小数点后6位。
输入样例#1:
3 10000 10000 10 5 20000 15 8 50000 5 6
输出样例#1:
12531.34496464
【数据规模与约定】
对于10%的数据,N=1;
对于40%的数据,N<=2;
对于60%的数据,N<=100;
对于80%的数据,N<=1000;
对于所有数据,N <= 10000,0 <= Eu <= 108,0 < si <= 100000,0 < ki <= 1,-100 < vi’ < 100。数据保证最终的答案不会超过105。
【提示】
必然存在一种最优的体力方案满足:蛋蛋在每段路上都采用匀速骑行的方式。
本题需要用到的数学姿势有:
其实这个题让我们求的就是f(v_1, v_2, \cdots, v_n) = \sum_{i=1}^n \frac{s_i}{v_i}的最小值,且要求\sum_{i=1}^n (k_i (v_i - v'_i)^2 s_i) \leq E_u。我们知道当不等式取等时肯定最优,则这个模型可以用拉格朗日乘数法求得极值。我们引入拉格朗日乘数\lambda,构建拉格朗日函数\mathcal{L}(v_1, v_2, \cdots, v_n, \lambda) = \sum_{i=1}^n \frac{s_i}{v_i} + \lambda(\sum_{i=1}^n (k_i (v_i - v'_i)^2 s_i) - E_u)。对这个函数求每一个未知数的偏导,最后得到的是方程组\frac{\partial \mathcal{L}}{\partial v_i} = - \frac{s_i}{v_i^2} + 2 \lambda k_i(v_i - v'_i)s_i = 0,整理得2 \lambda k_i(v_i - v'_i)v_i^2 = 1,观察得知这个式子左边的值关于v_i递增,故对于一个固定的\lambda可以二分求v_i。二分求v_i时,要考虑上下界的问题,上界可以任意,而下界要考虑,顺风的时候肯定是至少等于风速比较好,这样这一段做功就是0,而逆风的时候总不可能开倒车吧,因此只需要在风速和0之间取最大值即可。
下面考虑\lambda怎么搞,我们发现随\lambda增大,v_i减小,能量消耗减小,方案就越可能可行,因此可以考虑二分求\lambda。
// Code by KSkun, 2018/3
#include <cstdio>
#include <algorithm>
const int MAXN = 10005;
const double EPS = 1e-12, INF = 1e9;
int n;
double eu, s[MAXN], k[MAXN], u[MAXN], v[MAXN];
inline double calv(double x, int y) {
double l = std::max(0.0, u[y]), r = INF;
while(r - l > EPS) {
double mid = (l + r) / 2;
if(2.0 * x * k[y] * mid * mid * (mid - u[y]) <= 1.0) l = mid; else r = mid;
}
return l;
}
bool check(double x) {
double nowe = 0;
for(int i = 1; i <= n; i++) {
v[i] = calv(x, i);
nowe += k[i] * s[i] * (v[i] - u[i]) * (v[i] - u[i]);
}
return nowe - eu > EPS;
}
int main() {
scanf("%d%lf", &n, &eu);
for(int i = 1; i <= n; i++) {
scanf("%lf%lf%lf", &s[i], &k[i], &u[i]);
}
double l = 0, r = INF;
while(r - l > EPS) {
double mid = (l + r) / 2;
if(check(mid)) l = mid; else r = mid;
}
double ans = 0;
for(int i = 1; i <= n; i++) ans += s[i] / v[i];
printf("%.10lf\n", ans);
return 0;
}
题目地址:洛谷:【SP16549】QTREE6 – Query on a tree VI – 洛谷、SPOJ:SPOJ.com – Problem QTREE6
SPOJ QTREE系列:
You are given a tree (an acyclic undirected connected graph) with n nodes. The tree nodes are numbered from 1 to n. Each node has a color, white or black. All the nodes are black initially. We will ask you to perform some instructions of the following form:
给一棵树,最初点全是黑色的,操作:1.询问到u路径颜色相同的点有多少个2.改变颜色
输入格式:
The first line contains a number n that denotes the number of nodes in the tree (1 ≤ n ≤ 10^5). In each of the following n-1 lines, there will be two numbers (u, v) that describes an edge of the tree (1 ≤ u, v ≤ n). The next line contains a number m denoting number of operations we are going to process (1 ≤ m ≤ 10^5). Each of the following m lines describe an operation (t, u) as we mentioned above(0 ≤ t ≤ 1, 1 ≤ u ≤ n).
输出格式:
For each query operation, output the corresponding result.
输入样例#1:
5 1 2 1 3 1 4 1 5 3 0 1 1 1 0 1
输出样例#1:
5 1
输入样例#2:
7 1 2 1 3 2 4 2 5 3 6 3 7 4 0 1 1 1 0 2 0 3
输出样例#2:
7 3 3
参考资料:【Qtree】Query on a tree系列LCT解法 – CSDN博客
本题还是可以用边分……等等这题边分我做不动了,用的LCT。
我们考虑搞两棵LCT对应黑和白色的点构成的树。这样其实查询就变成了某一棵树上的子树大小查询。这个可以用子树信息LCT方便地维护。具体来说,就是统计一下跟当前点相连的轻边子树大小和Splay子树大小加起来。access的时候边合并Splay边更新轻边子树大小即可。
但是如果改变颜色的时候强行切边,有可能被菊花图卡掉。我们考虑把原树拉成一棵有根树,只切该点和父亲的边,这样,这棵LCT就满足所有儿子肯定同色,但是这个父亲可以跟儿子不同色这样的性质。我们在统计答案的时候找到子树根,然后看看子树根是否和儿子的颜色一致,不一致就取儿子的答案即可。
有一个小优化,可以DFS建树,把原树的边建成LCT上的轻边就好。
// Code by KSkun, 2018/3
#include <cstdio>
#include <cstring>
#include <algorithm>
inline char fgc() {
static char buf[100000], *p1 = buf, *p2 = buf;
return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) ? EOF : *p1++;
}
inline int readint() {
register int res = 0, neg = 1;
char c = fgc();
while(c < '0' || c > '9') {
if(c == '-') neg = -1;
c = fgc();
}
while(c >= '0' && c <= '9') {
res = res * 10 + c - '0';
c = fgc();
}
return res * neg;
}
const int MAXN = 100005, INF = 1e9;
struct Edge {
int to, w, nxt;
} gra[MAXN << 1];
int head[MAXN], ecnt, fa[MAXN], col[MAXN];
inline void addedge(int u, int v, int w) {
gra[ecnt] = Edge {v, w, head[u]}; head[u] = ecnt++;
}
struct LCT {
struct LCTNode {
int ch[2], fa, siz, s;
bool rev;
} lct[MAXN];
inline bool isleft(int p) {
return lct[lct[p].fa].ch[0] == p;
}
inline bool isroot(int p) {
register int fa = lct[p].fa;
return lct[fa].ch[0] != p && lct[fa].ch[1] != p;
}
inline void update(int p) {
register int ls = lct[p].ch[0], rs = lct[p].ch[1];
lct[p].siz = lct[p].s + lct[ls].siz + lct[rs].siz + 1;
}
inline void reverse(int p) {
std::swap(lct[p].ch[0], lct[p].ch[1]);
lct[p].rev ^= 1;
}
inline void pushdown(int p) {
register int ls = lct[p].ch[0], rs = lct[p].ch[1];
if(lct[p].rev) {
if(ls) reverse(ls);
if(rs) reverse(rs);
lct[p].rev ^= 1;
}
}
int sta[MAXN], stop;
inline void pushto(int p) {
stop = 0;
while(!isroot(p)) {
sta[stop++] = p;
p = lct[p].fa;
}
pushdown(p);
while(stop) {
pushdown(sta[--stop]);
}
}
inline void rotate(int p) {
register bool t = !isleft(p); register int fa = lct[p].fa, ffa = lct[fa].fa;
lct[p].fa = ffa; if(!isroot(fa)) lct[ffa].ch[!isleft(fa)] = p;
lct[fa].ch[t] = lct[p].ch[!t]; lct[lct[fa].ch[t]].fa = fa;
lct[p].ch[!t] = fa; lct[fa].fa = p;
update(fa);
}
inline void splay(int p) {
pushto(p);
for(register int fa = lct[p].fa; !isroot(p); rotate(p), fa = lct[p].fa) {
if(!isroot(fa)) rotate(isleft(fa) == isleft(p) ? fa : p);
}
update(p);
}
inline void access(int p) {
for(register int q = 0; p; q = p, p = lct[p].fa) {
splay(p);
if(lct[p].ch[1]) lct[p].s += lct[lct[p].ch[1]].siz;
if(q) lct[p].s -= lct[q].siz;
lct[p].ch[1] = q;
update(p);
}
}
inline void makert(int p) {
access(p);
splay(p);
reverse(p);
}
inline int findrt(int p) {
access(p);
splay(p);
while(lct[p].ch[0]) p = lct[p].ch[0];
return p;
}
inline void link(int u) {
access(fa[u]);
splay(fa[u]);
splay(u);
lct[fa[u]].ch[1] = u;
lct[u].fa = fa[u];
update(fa[u]);
}
inline void cut(int u) {
access(u);
splay(u);
lct[u].ch[0] = lct[lct[u].ch[0]].fa = 0;
update(u);
}
inline int query(int u) {
int c = col[u];
u = findrt(u);
splay(u);
return col[u] == c ? lct[u].siz : lct[lct[u].ch[1]].siz;
}
} L[2];
inline void dfs(int u, int f) {
for(int i = head[u]; ~i; i = gra[i].nxt) {
int v = gra[i].to;
if(v == f) continue;
fa[v] = L[0].lct[v].fa = u;
dfs(v, u);
L[0].lct[u].s += L[0].lct[v].siz;
}
L[0].update(u);
}
int n, q, ut, vt, op;
int main() {
memset(head, -1, sizeof(head));
n = readint();
for(int i = 1; i < n; i++) {
ut = readint(); vt = readint();
addedge(ut, vt, 1);
addedge(vt, ut, 1);
}
dfs(1, 0);
q = readint();
while(q--) {
op = readint(); ut = readint();
if(!op) {
printf("%d\n", L[col[ut]].query(ut));
} else {
if(fa[ut]) {
L[col[ut]].cut(ut);
L[col[ut] ^ 1].link(ut);
}
col[ut] ^= 1;
}
}
return 0;
}